{
(* Ūѿؿʤɤ *)
open Syntax
open Parser
(* open Type *)
}

(* ɽά *)
let space = [' ' '\t' '\n' '\r']
let digit = ['0'-'9']
let lower = ['a'-'z' '_']
let upper = ['A'-'Z']

rule token = parse
| space+
    { token lexbuf }
| '-' { MINUS }
| "(*"
    { comment lexbuf; (* ͥȤȤΤΥȥå *)
      token lexbuf }
| '(' { LPAREN }
| ')' { RPAREN }
| '$' { DOLLAR }
| ',' { COMMA }
| "true" { TRUE }
| "false" { FALSE }
| "begin" { BEGIN }
| "end" { END }
| "fun" { FUN }
| "fix" { FIX }
| "let" { LET }
| "rec" { REC }
| "Leaf" { LEAF }
| "Node" { NODE }
| "if" { IF }
| "then" { THEN }
| "else" { ELSE }
| "->" { ARROW }
| '=' { EQUAL }
| "in" { IN }
| "PC" { PC }
| "mod" { MOD }
(* | "~PC" { TILDEPC }*)
| "MLeaf" { MLEAF }
| "MNode" { MNODE }
| "[]" { NIL }
| "<>" { MNIL }
| "::" { CONS }
| "%%" { MCONS }
| '[' { LBRACKET }
| ']' { RBRACKET }
| '<' { LTHAN }
| '>' { RTHAN }
| "and" { AND }
| "match" { MATCH }
| "with" { WITH }
| '|' { VDASH }
| ';' { SEMI }
| '{' { LBRACE }
| '}' { RBRACE }
| '/' { SLASH }
| '\'' { QUOTE }
(* | '~' { TILDE } *)
| '~' { TILDE }
| '^' { HAT }
| "@@" { ATAT }
| '@' { AT }
| '.' { DOT }
| '\"' { STRING (string lexbuf) }
| '#' { SHARP }
| digit+
    { INT(int_of_string (Lexing.lexeme lexbuf)) }
(*| lower (digit|lower|upper|'_')* *)
(*    { IDENT(Lexing.lexeme lexbuf) } *)
| (digit|lower|upper|'_')* 
    { IDENT(Lexing.lexeme lexbuf) } 
| eof
    { EOF }
| _
    { Format.eprintf "unknown token %s near characters %d-%d@."
	(Lexing.lexeme lexbuf)
	(Lexing.lexeme_start lexbuf)
	(Lexing.lexeme_end lexbuf);
      failwith "lex error" }
and comment = parse
| "*)"
    { () }
| "(*"
    { comment lexbuf;
      comment lexbuf }
| eof
    { failwith "unterminated comment" }
| _
    { comment lexbuf }
and string = parse
| '\"' { "" }
| (digit|lower|upper|space|[',' '!' ';' '.' ':' '#'])+ 
  { let s = Lexing.lexeme lexbuf in
      s ^ (string lexbuf) }
| "\\n" { "\n" ^ (string lexbuf) }
| _
    { Format.eprintf "unknown token %s near characters %d-%d@."
	(Lexing.lexeme lexbuf)
	(Lexing.lexeme_start lexbuf)
	(Lexing.lexeme_end lexbuf);
      failwith "lex error" }
