let var str = {Alpha.id=0; Alpha.origin=str}

let rec buf_tree typ =
  let funtyp = Alpha.TFun(Alpha.TTree Alpha.UOne, Alpha.TTree Alpha.UOmega) in
  let wild = var "_" in
  let pcdata = var "pcdata" in
  let x = var "t" in
    match typ with
	Constr_gen.TTree(lts, typ1, typ2) ->
	  let f (l, typ) =
	    let attr = var "a" in
	    let tl = var "tl" in
	    let pat = Alpha.NodePattern(Alpha.LabelPattern l,
					Alpha.IdentPattern attr,
					Alpha.IdentPattern tl)
	    in
	    let t = (Typeinf.App(buf_list typ,
				 (Typeinf.Var tl, Alpha.TTreelist Alpha.UOne)),
		     Alpha.TTreelist Alpha.UOmega)
	    in
	    let t = (Typeinf.Node(Alpha.UOmega,
				  (Typeinf.Label l, Alpha.TLabel),
				  (Typeinf.Var attr, Alpha.TAttribute),
				  t),
		     Alpha.TTree Alpha.UOne)
	    in
	      (pat, t)
	  in
	  let f1 typ =
	    match typ with
		Constr_gen.Top ->
		  let pat = Alpha.LeafPattern (Alpha.IdentPattern wild) in
		  let t = (Typeinf.Leaf (Alpha.UOmega,
					 (Typeinf.Leaf (Alpha.UOmega, (Typeinf.String "", Alpha.TString)),
					  Alpha.TTree Alpha.UOmega)),
			   Alpha.TTree Alpha.UOmega)
		  in
		    (pat, t)
	      | Constr_gen.Bottom ->
		  let pat = Alpha.LeafPattern (Alpha.IdentPattern pcdata) in
		  let t = (Typeinf.Leaf(Alpha.UOmega,
					(Typeinf.Var pcdata,
					 Alpha.TTree Alpha.UOmega)),
			   Alpha.TTree Alpha.UOmega)
		  in
		    (pat, t)
	      | _ -> failwith "Cannot occur : buf_tree(Leaf)"
	  in
	  let f2 typ =
	    let l = var "l" in
	    let a = var "a" in
	    let tl = var "tl" in
	    match typ with
		Constr_gen.Top ->
		  let pat = Alpha.NodePattern(Alpha.IdentPattern l,
					      Alpha.IdentPattern a,
					      Alpha.IdentPattern tl)
		  in
		  let t =
		    Typeinf.Node(Alpha.UOmega,
				 (Typeinf.Var l, Alpha.TLabel),
				 (Typeinf.Var a, Alpha.TAttribute),
				 (Typeinf.Skip(tl, (Typeinf.Nil Alpha.UOmega,
						    Alpha.TTreelist Alpha.UOmega)),
				  Alpha.TTree Alpha.UOmega)),
		    Alpha.TTree Alpha.UOmega
		  in
		    (pat, t)
	      | Constr_gen.Bottom ->
		  let pat = Alpha.NodePattern(Alpha.IdentPattern l,
					      Alpha.IdentPattern a,
					      Alpha.IdentPattern tl)
		  in
		  let t =
		    Typeinf.Node(Alpha.UOmega,
				 (Typeinf.Var l, Alpha.TLabel),
				 (Typeinf.Var a, Alpha.TAttribute),
				 (Typeinf.LetS2M_tl(tl, (Typeinf.Var tl,
						         Alpha.TTreelist Alpha.UOmega)),
				  Alpha.TTree Alpha.UOmega)),
		    Alpha.TTree Alpha.UOmega
		  in
		    (pat, t)
	      | _ ->
		  let pat = Alpha.NodePattern(Alpha.IdentPattern l,
					      Alpha.IdentPattern a,
					      Alpha.IdentPattern tl)
		  in
		  let t = (Typeinf.App(buf_list typ,
				       (Typeinf.Var tl, Alpha.TTreelist Alpha.UOne)),
			   Alpha.TTreelist Alpha.UOmega)
		  in
		  let t =
		    Typeinf.Node(Alpha.UOmega,
				 (Typeinf.Var l, Alpha.TLabel),
				 (Typeinf.Var a, Alpha.TAttribute),
				 t),
		    Alpha.TTree Alpha.UOmega
		  in
		    (pat, t)
	  in
	    (Typeinf.Fix(var "", (x, Alpha.UOmega), 
			 (Typeinf.Match(Alpha.TTree Alpha.UOne, x,
					List.map f lts @ [f1 typ1; f2 typ2]),
			  Alpha.TTree Alpha.UOmega)),
	     funtyp)
      | Constr_gen.Top -> (Typeinf.Var (var "skip_tree"), funtyp)
      | Constr_gen.Bottom -> (Typeinf.Var (var "s2m_t"), funtyp)
      | Constr_gen.TRec _ -> failwith "Not implemented : Part_buf.buf_tree TRec"
      | _ -> failwith "Cannot occur : buf_tree"

and buf_list typ =
  let funtyp = Alpha.TFun(Alpha.TTree Alpha.UOne, Alpha.TTree Alpha.UOmega) in
  match typ with
      Constr_gen.Top -> (Typeinf.Var (var "skip_list"), funtyp)
    | Constr_gen.Bottom -> (Typeinf.Var (var "s2m_tl"), funtyp)
    | Constr_gen.TList Constr_gen.Top -> (Typeinf.Var (var "skip_list"), funtyp)
    | Constr_gen.TList Constr_gen.Bottom -> (Typeinf.Var (var "s2m_tl"), funtyp)
    | Constr_gen.TList typ ->
	let l = var "l" in
	let f = var "f" in
	let hd = var "hd" in
	let tl = var "tl" in
	let match1 =
	  let pat = Alpha.ConsPattern(Alpha.IdentPattern hd,
				      Alpha.IdentPattern tl)
	  in
	  let h = var "h" in
	  let tlet t =
	    Typeinf.Let((h, Alpha.UOmega),
			(Typeinf.App(buf_tree typ,
				     (Typeinf.Var hd, Alpha.TTree Alpha.UOne)),
			 Alpha.TTree Alpha.UOmega),
			t),
	    Alpha.TTreelist Alpha.UOmega
	  in
	  let t = (Typeinf.Cons(Alpha.UOmega,
				(Typeinf.Var h, Alpha.TTree Alpha.UOmega),
				(Typeinf.App((Typeinf.Var f,
					      Alpha.TFun(Alpha.TTreelist Alpha.UOne,
							 Alpha.TTreelist Alpha.UOmega)),
					     (Typeinf.Var tl, Alpha.TTreelist Alpha.UOne)),
				 Alpha.TTree Alpha.UOmega)),
		   Alpha.TTreelist Alpha.UOmega)
	  in
	    (pat, tlet t)
	in
	let match2 =
	  let pat = Alpha.NilPattern in
	  let t = (Typeinf.Nil(Alpha.UOmega), Alpha.TTreelist Alpha.UOmega) in
	    (pat, t)
	in
	let t = (Typeinf.Match(Alpha.TTreelist Alpha.UOne, l, [match1; match2]),
		 Alpha.TTreelist Alpha.UOmega)
	in
	  (Typeinf.Fix(f, (l,Alpha.UOmega), t), funtyp)
    | Constr_gen.TRec _ -> failwith "Not implemented : Part_buf.buf_list TRec"
    | _ -> failwith "Cannot occur : buf_list"

let insert_buf (t, typ) constrs =
  let rec insert_buf' (t, typ) =
    match t with
	Typeinf.AttrGet(t, l) -> Typeinf.AttrGet(insert_buf' t, l), typ
      | Typeinf.BinOp(op, t1, t2) -> Typeinf.BinOp(op, insert_buf' t1, insert_buf' t2), typ
      | Typeinf.Fix(f, x, t) -> Typeinf.Fix(f, x, insert_buf' t), typ
      | Typeinf.App(t1, t2) -> Typeinf.App(insert_buf' t1, insert_buf' t2), typ
      | Typeinf.Let(x, t1, t2) -> Typeinf.Let(x, insert_buf' t1, insert_buf' t2), typ
      | Typeinf.Letrecs(xts, t) ->
	  let f (x, t) = (x, insert_buf' t) in
	    Typeinf.Letrecs(List.map f xts, insert_buf' t), typ
      | Typeinf.If(t1, t2, t3) -> Typeinf.If(insert_buf' t1, insert_buf' t2, insert_buf' t3), typ
      | Typeinf.Leaf(u, t) -> Typeinf.Leaf(u, insert_buf' t), typ
      | Typeinf.Node(u, t1, t2, t3) -> Typeinf.Node(u, insert_buf' t1, insert_buf' t2, insert_buf' t3), typ
      | Typeinf.Cons(u, t1, t2) -> Typeinf.Cons(u, insert_buf' t1, insert_buf' t2), typ
      | Typeinf.Match(typ, x, matchs) ->
	  let f (pat, t) = (pat, insert_buf' t) in
	    Typeinf.Match(typ, x, List.map f matchs), typ
      | Typeinf.LetS2M_t(x, t) ->
	  let buf =
	    Typeinf.App(buf_tree (Constr_solv.get_typ [x.Alpha.id;-1] constrs),
			(Typeinf.Var x, Alpha.TTree Alpha.UOne)),
	    Alpha.TTree Alpha.UOmega
	  in
	    Typeinf.Let((x,Alpha.UOmega), buf, insert_buf' t), typ
      | Typeinf.LetS2M_tl(x, t) ->
	  let buf =
	    Typeinf.App(buf_list (Constr_solv.get_typ [x.Alpha.id;-1] constrs),
			(Typeinf.Var x, Alpha.TTree Alpha.UOne)),
	    Alpha.TTreelist Alpha.UOmega
	  in
	    Typeinf.Let((x,Alpha.UOmega), buf, insert_buf' t), typ
      | Typeinf.M2S_t t -> Typeinf.M2S_t (insert_buf' t), typ
      | Typeinf.M2S_tl t -> Typeinf.M2S_tl (insert_buf' t), typ
      | Typeinf.Copy _ -> t, typ
      | Typeinf.Skip(t, t1) -> Typeinf.Skip(t, insert_buf' t1), typ
      | Typeinf.Coerce _
      | Typeinf.CoerceOut _ -> failwith "Cannot occur : insert_buf"
      | _ -> (t, typ)
  in
    insert_buf' (t, typ)
