
let rec scan_pc = fun buf -> fun l -> 
  match l with 
      hd::tl ->
	begin
	  match hd with PC x -> scan_pc x tl | _ -> scan_pc buf tl
	end
    | [] -> buf
in
let get_id = fun t -> match t with <id>@_$l -> scan_pc "" l in
let get_firstname = fun t -> match t with <firstname>@_$l -> scan_pc "" l in
let get_lastname = fun t -> match t with <lastname>@_$l -> scan_pc "" l in
let get_street = fun t -> match t with <street>@_$l -> scan_pc "" l in
let get_city = fun t -> match t with <city>@_$l -> scan_pc "" l in
let get_state = fun t -> match t with <state>@_$l -> scan_pc "" l in
let get_zip = fun t -> match t with <zip>@_$l -> scan_pc "" l in
let rec f = fun t ->
  match t with
      <table>@_$ts -> <table>@{}$(g ts)
    | <row>@_$ts -> 
	begin
	  match ts with id::tl ->
	    let id = get_id id in
	      match tl with firstname::tl ->
		let firstname = get_firstname firstname in
		  match tl with lastname::tl ->
		    let lastname = get_lastname lastname in
		      match tl with street::tl ->
			let street = get_street street in
			  match tl with city::tl ->
			    let city = get_city city in
			      match tl with state::tl ->
				let state = get_state state in
				  match tl with zip::tl ->
				    let zip = get_zip zip in
				      match tl with [] ->
					<address>@
					  { id = id;
					    firstname = firstname;
					    lastname = lastname;
					    street = street;
					    city = city;
					    state = state;
					    zip = zip } $ []
	end
    | PC x -> PC x
    | t -> t
and g = fun ts ->
  match ts with
      [] -> []
    | hd::tl -> (f hd)::(g tl)
in
  f
