
(* let get_id = fun /t/ -> match t with <id>@_[x::[]] -> match x with PC x -> x in *)
let rec scan_pc = fun buf -> fun l -> 
  match l with 
      hd::tl ->
	begin
	  match hd with PC x -> scan_pc x tl | _ -> scan_pc buf tl
	end
    | [] -> buf
in
let get_id = fun t -> match t with <id>@_$l -> scan_pc "" l in
let get_firstname = fun t -> match t with <firstname>@_$l -> scan_pc "" l in
let get_lastname = fun t -> match t with <lastname>@_$l -> scan_pc "" l in
let get_street = fun t -> match t with <street>@_$l -> scan_pc "" l in
let get_city = fun t -> match t with <city>@_$l -> scan_pc "" l in
let get_state = fun t -> match t with <state>@_$l -> scan_pc "" l in
let get_zip = fun t -> match t with <zip>@_$l -> scan_pc "" l in
let process_row = fun t ->
  match t with
      id::tl ->
	let id_pc = get_id id in
	  if id_pc = "0432" then
	    match tl with firstname::tl -> (* firstname::<lastname>@_[lastnames]:: .... *)
	      let firstname_pc = get_firstname firstname in
		match tl with lastname::tl ->
		  let lastname_pc = get_lastname lastname in
		    match tl with street::tl ->
		      let street_pc = get_street street in
			match tl with city::tl ->
			  let city_pc = get_city city in
			    match tl with state::tl ->
			      let state_pc = get_state state in
				match tl with zip::[] ->
				  let zip_pc = get_zip zip in
				    <html>@{}$[
				      <head>@{bgcolor = "#ffffff"}$[];
				      <body>@{}$[
					<table>@{border="0"}$[
					  <tr>@{}$[
					    <td>@{colspan="2"; bgcolor="#000000"}$[
					      <font>@{color="#ffffff"}$[(PC "personel record #")^(PC id_pc)]
					    ]
					  ];
					  <tr>@{}$[
					    <td>@{bgcolor="#888888"}$[(PC "First Name:")];
					    <td>@{bgcolor="#dddddd"}$[PC firstname_pc]
					  ];
					  <tr>@{}$[
					    <td>@{bgcolor="#888888"}$[(PC "Last Name:")];
					    <td>@{bgcolor="#dddddd"}$[PC lastname_pc]
					  ];
					  <tr>@{}$[
					    <td>@{bgcolor="#888888"}$[(PC "Street:")];
					    <td>@{bgcolor="#dddddd"}$[PC street_pc]
					  ];
					  <tr>@{}$[
					    <td>@{bgcolor="#888888"}$[(PC "City:")];
					    <td>@{bgcolor="#dddddd"}$[PC city_pc]
					  ];
					  <tr>@{}$[
					    <td>@{bgcolor="#888888"}$[(PC "State:")];
					    <td>@{bgcolor="#dddddd"}$[PC state_pc]
					  ];
					  <tr>@{}$[
					    <td>@{bgcolor="#888888"}$[(PC "Zip:")];
					    <td>@{bgcolor="#dddddd"}$[PC zip_pc]
					  ]
					]
				      ]
				    ]
	  else
	    match tl with firstname::tl ->
	      0 #
	      match tl with lastname::tl ->
		0 #
		match tl with street::tl ->
		  0 #
		  match tl with city::tl ->
		    0 #
		    match tl with state::tl ->
		      0 #
		      match tl with zip::tl ->
			0 #
			match tl with
			  [] -> PC ""
	      (*
		begin
		(skip_tree id) # (skip_tree firstname) # (skip_tree lastname) #
		(skip_tree street) # (skip_tree city) # (skip_tree state) # (skip_tree zip)
		end
	      *)
in
let rec g = fun t ->
  match t with
      <row>@_$t1 -> process_row t1
(*
    | PC x -> (* <hoge>@{}[] *) PC x
    | _ -> <hoge>@{}[]
*)
in
let rec f1 = fun ts ->
  match ts with
      hd::tl -> (g hd)::(f1 tl)
    | [] -> []
in
let rec f = fun t ->
  match t with
      <table>@_$ts -> f1 ts
in
  f
