
let rec scan_pc = fun buf -> fun l -> 
  match l with 
      hd::tl ->
	begin
	  match hd with PC x -> scan_pc x tl | _ -> scan_pc buf tl
	end
    | [] -> buf
in
let get_firstname = fun t -> match t with <firstname>@_$l -> scan_pc "" l in
let get_lastname = fun t -> match t with <lastname>@_$l -> scan_pc "" l in
let rec process_row = fun t ->
  match t with
      id::tl -> id #
	match tl with firstname::tl ->
	  let firstname = get_firstname firstname in
	    match tl with lastname::tl ->
	      let lastname = get_lastname lastname in
		match tl with street::tl -> street #
		  match tl with city::tl -> city #
		    match tl with state::tl -> state #
		      match tl with zip::tl -> zip #
			match tl with [] ->
			  <row>@{}$[
			    <first>@{}$[PC firstname];
			    <last>@{}$[PC lastname]
			  ]
in
let rec g = fun t ->
  match t with
      <row>@_$t1 -> process_row t1
in
let rec f1 = fun ts ->
  match ts with
      hd::tl -> (g hd)::(f1 tl)
    | [] -> []
in
let rec f = fun t ->
  match t with
      <table>@_$ts -> <document>@{}$(f1 ts)
in
  f
