open Syntax

let rec trans_let t =
  match t with
      String _ | Int _ | True | False | Pcdata _ 
    | Attribute _ | Label _ | Var _ -> t
    | BinOp(binop, t1, t2) ->
	BinOp(binop, (trans_let t1), (trans_let t2))
    | Fix(f, x, body) ->
	Fix(f, x, (trans_let body))
    | Lam(x, t) ->
	Fix("", x, (trans_let t))
    | Let(x, t1, t2) ->
	App(Fix("", x, (trans_let t2)), (trans_let t1))
    | Syntax.Letrecs(fts, t) ->
	let rec hoge fts =
	  (match fts with
	       (f, t)::tl ->
		 (f, (trans_let t))::(hoge tl)
	     | [] -> [])
	in
	  Letrecs((hoge fts), (trans_let t))
    | Leaf t -> Leaf (trans_let t)
    | Node(t1, t2, t3) -> Node(trans_let t1, trans_let t2, trans_let t3)
    | Cons(t1, t2) -> Cons(trans_let t1, trans_let t2)
    | Nil -> Nil
    | Match(t_match, matchs) ->
	let rec hoge pts = 
	  (match pts with
	       (p, t)::tl ->
		 (p, (trans_let t))::(hoge tl)
	     | [] -> [])
	in 
	  Match((trans_let t_match), (hoge matchs))
    | If(t0, t1, t2) ->
	If(trans_let t0, trans_let t1, trans_let t2)
